// uses framework Cocoa
// uses framework OpenGL
#define MAIN
#include "GL_utilities.h"
#include "MicroGlut.h"
#include "LittleOBJLoader.h"
#include "LoadTGA.h"

// Globals
// Data would normally be read from files
GLfloat vertices[] = {	-1.0f,-1.0f,0.0f,
							-1.0f,1.0f,0.0f,
							1.0f,1.0f,0.0f,
							1.0f,-1.0f,0.0f};
GLfloat texcoord[] = {	0.0f, 1.0f,
						0.0f, 0.0f,
						1.0f, 0.0f,
						1.0f, 1.0f};
GLuint indices[] = {0,1,3, 3,1,2};


// Model (just a quad)
Model *m;
// Switch between CPU and shader generation
int flag = 0;

// Reference to shader program
GLuint program;

GLuint tex1, tex2;

void init(void)
{
	// GL inits
	glClearColor(0.2,0.2,0.5,0);
	glEnable(GL_DEPTH_TEST);
	printError("GL inits");

	// Load and compile shader
	program = loadShaders("minimal.vert", "scroll.frag");
	glUseProgram(program);
	printError("init shader");
	
	// Upload geometry to the GPU:
	m = LoadDataToModel((vec3 *)vertices, NULL, (vec2 *)texcoord, NULL, indices, 4, 6);

	// End of upload of geometry
	printError("init arrays");
	
	float t1scalex, t1scaley, t2scale;
	
//	LoadTGATextureSimple("grass.tga", &tex1); // offset
//	LoadTGATextureSimple("bark2.tga", &tex2); // background
//	t1 = texture(tex1, texCoord + vec2(time, time));
//	t2 = texture(tex2, texCoord + vec2(t1) * 0.1);

// Frsta test. Snyggt!
	LoadTGATextureSimple("grass.tga", &tex1); // offset
	LoadTGATextureSimple("bark2.tga", &tex2); // background
	t1scalex = 1.0;
	t1scaley = 1.0;
	t2scale = 0.1;
//	t1 = texture(tex1, texCoord + vec2(time, time));
//	t2 = texture(tex2, texCoord + vec2(t1) * 0.1);

/*
// Sin wave offset
	LoadTGATextureSimple("diagonalsin.tga", &tex1);
	LoadTGATextureSimple("bark2.tga", &tex2); // background
//	t1 = texture(tex1, texCoord + vec2(time, time));
//	t2 = texture(tex2, texCoord + vec2(t1) * 0.01);
	t1scalex = 1.0;
	t1scaley = 1.0;
	t2scale = 0.01;
*/
	glUniform1f(glGetUniformLocation(program, "t1scalex"), t1scalex); // Texture unit 0
	glUniform1f(glGetUniformLocation(program, "t1scaley"), t1scaley); // Texture unit 0
	glUniform1f(glGetUniformLocation(program, "t2scale"), t2scale); // Texture unit 0

	glActiveTexture(GL_TEXTURE0);
	glBindTexture(GL_TEXTURE_2D, tex1);
	glActiveTexture(GL_TEXTURE1);
	glBindTexture(GL_TEXTURE_2D, tex2);

	glUniform1i(glGetUniformLocation(program, "tex1"), 0); // Texture unit 0
	glUniform1i(glGetUniformLocation(program, "tex2"), 1); // Texture unit 0
}

// Switch on any key
void key(unsigned char key, int x, int y)
{
	flag = !flag;
	glUniform1i(glGetUniformLocation(program, "flag"), flag); // shader generation off
	printf("Changed flag to %d\n", flag);
	glutPostRedisplay();
}

void display(void)
{
	printError("pre display");
	
	// clear the screen
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	
	glUniform1i(glGetUniformLocation(program, "iTime"), glutGet(GLUT_ELAPSED_TIME));
	
	DrawModel(m, program, "inPosition", NULL, "inTexCoord");
	
	printError("display");
	
	glutSwapBuffers();
}

int main(int argc, char *argv[])
{
	glutInit(&argc, argv);
	glutInitContextVersion(3, 2);
	glutInitWindowSize(512, 512);
	glutCreateWindow ("Scrolling texture");
	glutDisplayFunc(display); 
	glutKeyboardFunc(key);
	glutRepeatingTimer(20);
	init ();
	glutMainLoop();
}
